<template>
  <section class="wrapper">
    <div
      class="init"
      v-if="isInit">
      <p>Travelling...</p>
    </div>
    <div v-else-if="isPlayer">
      <div v-if="isBaseMenu">
        <b-button
          @click="charAttack">
          attack
        </b-button>
        <b-button
          @click="charSkill">
          skill
        </b-button>
        <b-button
          @click="charItem">
          item
        </b-button>
      </div>

      <div v-else-if="isSkillMenu">
        <ul>
          <li
            v-for="skill of char.char_skills"
            :key="skill.name"
            @click="use(skill)">
            {{ skill.name }}
          </li>
        </ul>
      </div>

      <div v-else-if="isItemMenu">
        <ul>
          <li
            v-for="item of char.bag"
            :key="">

          </li>
        </ul>
      </div>
    </div>
    <div v-else-if="isFoe">
      foe time
    </div>
    <div v-else-if="isDest">
      <p v-if="N == 0">no monsters to fight</p>
      <p v-else>you win</p>
    </div>
    <div v-else-if="isDept">
      you lost
    </div>
  </section>
</template>

<script>
export default {
  data() {
    return {
      cur_st: 0,
      cur_menu: 0,
      N: null,
      init_exit: null,
      player_exit: null,
      foe_exit: null,
      cur_foe: null,
      foes: [],
      defeated_foes: [],
      char_move: null,
      char: null,
      path: null
    };
  },
  created() {
    // pegar da requisição

    this.path = this.$store.state.cur_path;
    this.char = this.$store.state.cur_char;
    this.N = Math.floor(Math.random() * (this.path.length+1));

    this._selectMonsters();
  },
  computed: {
    isInit() {
      return this.cur_st == 0;
    },
    isPlayer() {
      return this.cur_st == 1;
    },
    isFoe() {
      return this.cur_st == 2;
    },
    isDest() {
      return this.cur_st == 3;
    },
    isDept() {
      return this.cur_st == 4;
    },
    isBaseMenu() {
      return this.cur_menu == 0;
    },
    isSkillMenu() {
      return this.cur_menu == 1;
    },
    isItemMenu() {
      return this.cur_menu == 2;
    }
  },
  watch: {
    init_exit() {
      if (this.init_exit !== null) {
        this.player_exit = null;
        this.foe_exit = null;

        switch (this.init_exit) {
          case 0:
            this.destST();
            break;
          case 1:
            this.playerAttackST();
            break;
          case 2:
            this.foeAttackST();
            break;
        }
      }
    },
    player_exit() {
      if (this.player_exit !== null) {
        this.init_exit = null;
        this.foe_exit = null;

        switch (this.player_exit) {
          case 0:
            this.foeAttackST();
            break;
          case 1:
            this.destST();
            break;
        }
      }
    },
    foe_exit() {
      if (this.foe_exit !== null) {
        this.player_exit = null;
        this.init_exit = null;

        switch (this.foe_exit) {
          case 0:
            this.playerAttackST();
            break;
          case 1:
            this.deptST();
            break;
        }
      }
    }
  },
  methods: {
    _selectMonsters() {
      if (this.N <= 0) {
        this.init_exit = 0;
      } else {
        let ins = this;

        this.$axios({
          method: 'get',
          url: `http://localhost:3000/paths/${this.path.id}/monsters`
        })
          .then(res => {
            let bfoes = res.data,
                aux_foes = [];
            
            for (let foe of bfoes) {
              foe.curr_hp = foe.stats.hp;
              foe.curr_mp = foe.stats.mp;
              foe.curr_ap = foe.stats.ap;
              aux_foes = aux_foes.concat(foe);
            }

            for (let i = 0; i < ins.N; i++) {
              let index = Math.floor(Math.random() * aux_foes.length),
                  a_foe = Object.assign({},aux_foes[index]);

              ins.foes = ins.foes.concat(a_foe);
            }
            
            ins.cur_foe = ins.foes.pop();
            ins.init_exit = ins.cur_foe.stats.agi > ins.char.char_stat.agi ? 2 : 1;
          })
          .catch(err => {
            console.log(err);

            ins.$router.push('/');
          });
      }
    },
    destST() {
      this.cur_st = 3;

      let loc_id = this.$store.state.cur_path.destination_id,
          ins = this;

      console.log('PORRA');
      this.$axios({
        method: 'get',
        url: `http://localhost:3000/locations/${loc_id}`
      })
        .then(res => {
          ins.$store.state.cur_loc = res.data;
          ins.$store.state.cur_char = ins.char;
          let drops = [];
          for (let dfoe of ins.defeated_foes) {
            for (let drop of dfoe.items) {
              if (Math.random() < 1) {
                drops = drops.concat(drop);
              }
            }
          }
          console.log('PORRA2');

          if (!ins.char.char_items)
            ins.char.char_items = [];
          ins.char.char_items = ins.char.char_items.concat(drops);
          // emit 'battle-end' event indicating where to
          setTimeout(() => {
            ins.$emit('battle-end');
          }, 2000);
        })
        .catch(err => {
          ins.$router.push('/');
        });

    },
    deptST() {
      this.cur_st = 4;

      this.$store.state.cur_char = this.char;

      // emit 'battle-end' event indicating where to
      let ins = this;
      setTimeout(() => {
        ins.$emit('battle-end', {to: this.path.departure_id});
      }, 2000);
    },
    playerAttackST() {
      this.cur_st = 1;

      // nada mais a fazer, porque o resto
      // está condicionado às escolhas dos
      // botões => 'triggers' de click

      // lembrar de usar 'applyEffects'
    },
    foeAttackST() {
      this.cur_st = 2;

      // listar ações possíveis
      // sortear uma ação
      // computar alterações
      // verificar win-lose => estado seguinte

      let actions = this.cur_foe.skills.concat('attack'),
          index = Math.floor(Math.random() * actions.length),
          action = actions[index],
          statmap = ['hp','mp','ap','str','agi','dex','int','def','luk'];

      let target = null,
          stat = null,
          amount = null;

      if (action == 'attack') {
        target = this.char;
        stat = 0;
        amount = Math.max(this.cur_foe.stats.str - target.char_stat.def, 0);
      } else {
        target = action.special.target_self ? this.cur_foe : this.char;

        if (target == this.cur_foe)
          amount = (action.special.target_self ? 1 : -1) * action.special.power / 10 * target.stats[statmap[action.ref_stat]];
        else 
          amount = (action.special.target_self ? 1 : -1) * action.special.power / 10 * target.char_stat[statmap[action.ref_stat]];

        stat = action.special.stat;

        if (Math.random() * 100 > action.accuracy)
          amount = 0;
      }

      let ins = this;
      setTimeout(() => {
        ins.applyEffects(target, stat, amount, 'foe_exit');
      }, 500);
    },
    applyEffects(target, stat, amount, exit_type) {
      // exit_type: String
      //    either 'player_exit' or 'foe_exit'

      // note: if target is foe and it dies
      //    - get another 
      //    - or it was 'last of its kind'

      // default behavior:
      //    this[exit_type] = lastTargetOfKindDies() ? 1 : 0;

      let statsmap = ['hp','mp','ap'];
      target[`curr_${statsmap[stat]}`] -= amount;

      if (exit_type == 'foe_exit') {
        // verifica se cur_foe matou personagem
        this[exit_type] = target.curr_hp > 0 ? 0 : 1;
      } else {
        if (target.curr_hp > 0) // char não matou cur_foe
          this[exit_type] = 0;
        else { // char matou o cur_foe
          this.defeated_foes = this.defeated_foes.concat(this.cur_foe);
          let aux_foe = this.foes.pop();
          if (aux_foe === undefined) // era o último foe
            this[exit_type] = 1;
          else { // não era o último foe
            this.cur_foe = aux_foe;
            this[exit_type] = 0;
          }
        }
      }
    },
    charAttack() {
      this.applyEffects(
        this.cur_foe, 0, 
        Math.max(
          this.char.char_stat.str - this.cur_foe.stats.def, 
          1),
        'player_exit');
    },
    charSkill() {
      this.cur_menu = 1;
    },
    charItem() {
      this.cur_menu = 2;
    },
    use(special) {
      let target = null,
          stat = null,
          amount = null;
          
      if (special.cost) {
        // é item
        
        target = special.skill_special.target_self ? this.cur_foe : this.char;
        amount = (special.skill_special.target_self ? 1 : -1) * special.skill_special.power;
        stat = special.skill_special.stat;

        if (Math.random() * 100 > special.accuracy)
          amount = 0;

      } else {
        // é skill
        let statmap = ['hp','mp','ap','str','agi','dex','int','def','luk'];
        
        target = special.skill_special.target_self ? this.char : this.cur_foe;

        if (target == this.cur_foe)
          amount = (special.skill_special.target_self ? 1 : -1) * special.skill_special.power / 10 * target.stats[statmap[special.ref_stat]];
        else 
          amount = (special.skill_special.target_self ? 1 : -1) * special.skill_special.power / 10 * target.char_stat[statmap[special.ref_stat]];

        stat = special.skill_special.stat;

        if (Math.random() * 100 > special.accuracy)
          amount = 0;
      }
      this.cur_menu = 0;
      this.applyEffects(target, stat, amount, 'player_exit');
    }
  }
}
</script>
